Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.apache.commons.validator
Class UrlValidator

    java.lang.Object
      |
      +--org.apache.commons.validator.UrlValidator

All Implemented Interfaces:
  java.io.Serializable

public class UrlValidator
extends java.lang.Object
implements java.io.Serializable

Validates URLs.

Behavour of validation is modified by passing in options:
- ALLOW_2_SLASHES - [FALSE] Allows double '/' characters in the path component.
- NO_FRAGMENT- [FALSE] By default fragments are allowed, if this option is included then fragments are flagged as illegal.
- ALLOW_ALL_SCHEMES - [FALSE] By default only http, https, and ftp are considered valid schemes. Enabling this option will let any scheme pass validation.

Originally based in on php script by Debbie Dyer, validation.php v1.2b, Date: 03/07/02, http://javascript.internet.com. However, this validation now bears little resemblance to the php original.

       Example of usage:
       Construct a UrlValidator with valid schemes of "http", and "https".

        String[] schemes = {"http","https"}.
        UrlValidator urlValidator = new UrlValidator(schemes);
        if (urlValidator.isValid("ftp://foo.bar.com/")) {
           System.out.println("url is valid");
        } else {
           System.out.println("url is invalid");
        }

        prints "url is invalid"
       If instead the default constructor is used.

        UrlValidator urlValidator = new UrlValidator();
        if (urlValidator.isValid("ftp://foo.bar.com/")) {
           System.out.println("url is valid");
        } else {
           System.out.println("url is invalid");
        }

       prints out "url is valid"

Since:
  Validator 1.1
Version:
  $Revision: 478334 $ $Date: 2006-11-22 21:31:54 +0000 (Wed, 22 Nov 2006) $
See Also:
  Uniform Resource Identifiers (URI): Generic Syntax , Serialized Form

Field Summary
`static int` | `ALLOW_2_SLASHES` Allow two slashes in the path component of the URL.
`static int` | `ALLOW_ALL_SCHEMES` Allows all validly formatted schemes to pass validation instead of supplying a set of valid schemes.
`protected java.lang.String[]` | `defaultSchemes` If no schemes are provided, default to this set.
`static int` | `NO_FRAGMENTS` Enabling this options disallows any URL fragments.

Constructor Summary
`UrlValidator()` Create a UrlValidator with default properties.
`UrlValidator(int options)` Initialize a UrlValidator with the given validation options.
`UrlValidator(java.lang.String[] schemes)` Behavior of validation is modified by passing in several strings options:
`UrlValidator(java.lang.String[] schemes, int options)` Behavour of validation is modified by passing in options:

Method Summary
`protected int` | `countToken(java.lang.String token, java.lang.String target)` Returns the number of times the token appears in the target.
`boolean` | `isValid(java.lang.String value)` Checks if a field has a valid url address.
`protected boolean` | `isValidAuthority(java.lang.String authority)` Returns true if the authority is properly formatted.
`protected boolean` | `isValidFragment(java.lang.String fragment)` Returns true if the given fragment is null or fragments are allowed.
`protected boolean` | `isValidPath(java.lang.String path)` Returns true if the path is valid.
`protected boolean` | `isValidQuery(java.lang.String query)` Returns true if the query is null or it's a properly formatted query string.
`protected boolean` | `isValidScheme(java.lang.String scheme)` Validate scheme.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### ALLOW_ALL_SCHEMES

    public static final int ALLOW_ALL_SCHEMES

  Allows all validly formatted schemes to pass validation instead of supplying a set of valid schemes.

### ALLOW_2_SLASHES

    public static final int ALLOW_2_SLASHES

  Allow two slashes in the path component of the URL.

### NO_FRAGMENTS

    public static final int NO_FRAGMENTS

  Enabling this options disallows any URL fragments.

### defaultSchemes

    protected java.lang.String[] defaultSchemes

  If no schemes are provided, default to this set.

Constructor Detail

### UrlValidator

    public UrlValidator()

  Create a UrlValidator with default properties.

### UrlValidator

    public UrlValidator(java.lang.String[] schemes)

  Behavior of validation is modified by passing in several strings options:
  Parameters:
    `schemes` - Pass in one or more url schemes to consider valid, passing in a null will default to "http,https,ftp" being valid. If a non-null schemes is specified then all valid schemes must be specified. Setting the ALLOW_ALL_SCHEMES option will ignore the contents of schemes.

### UrlValidator

    public UrlValidator(int options)

  Initialize a UrlValidator with the given validation options.
  Parameters:
    `options` - The options should be set using the public constants declared in this class. To set multiple options you simply add them together. For example, ALLOW_2_SLASHES + NO_FRAGMENTS enables both of those options.

### UrlValidator

    public UrlValidator(java.lang.String[] schemes,
                        int options)

  Behavour of validation is modified by passing in options:
  Parameters:
    `schemes` - The set of valid schemes.
    `options` - The options should be set using the public constants declared in this class. To set multiple options you simply add them together. For example, ALLOW_2_SLASHES + NO_FRAGMENTS enables both of those options.

Method Detail

### isValid

    public boolean isValid(java.lang.String value)

  Checks if a field has a valid url address.

  Parameters:
    `value` - The value validation is being performed on. A `null` value is considered invalid.
  Returns:
    true if the url is valid.

### isValidScheme

    protected boolean isValidScheme(java.lang.String scheme)

  Validate scheme. If schemes[] was initialized to a non null, then only those scheme's are allowed. Note this is slightly different than for the constructor.
  Parameters:
    `scheme` - The scheme to validate. A `null` value is considered invalid.
  Returns:
    true if valid.

### isValidAuthority

    protected boolean isValidAuthority(java.lang.String authority)

  Returns true if the authority is properly formatted. An authority is the combination of hostname and port. A `null` authority value is considered invalid.
  Parameters:
    `authority` - Authority value to validate.
  Returns:
    true if authority (hostname and port) is valid.

### isValidPath

    protected boolean isValidPath(java.lang.String path)

  Returns true if the path is valid. A `null` value is considered invalid.
  Parameters:
    `path` - Path value to validate.
  Returns:
    true if path is valid.

### isValidQuery

    protected boolean isValidQuery(java.lang.String query)

  Returns true if the query is null or it's a properly formatted query string.
  Parameters:
    `query` - Query value to validate.
  Returns:
    true if query is valid.

### isValidFragment

    protected boolean isValidFragment(java.lang.String fragment)

  Returns true if the given fragment is null or fragments are allowed.
  Parameters:
    `fragment` - Fragment value to validate.
  Returns:
    true if fragment is valid.

### countToken

    protected int countToken(java.lang.String token,
                             java.lang.String target)

  Returns the number of times the token appears in the target.
  Parameters:
    `token` - Token value to be counted.
    `target` - Target value to count tokens in.
  Returns:
    the number of tokens.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2002-2006 The Apache Software Foundation. All Rights Reserved.